
% Code to make figure 2a : three different initial conditions

clear all;

%CONTROL COMMANDS

% target of the movement
TARGET = 2;

%VARIABLES: INITIAL CONDITIONS

h_d(1)=0;
x_d(1)=1;
y_d(1)=0;

h_d2(1)=0;
x_d2(1)=3;
y_d2(1)=0;

h_d3(1)=0;
x_d3(1)=-1;
y_d3(1)=0;

%PARAMETERS

%discrete system
b = 10;

% EQ + INTEGRATION

%integration
dt   = 0.001; %time step 
T(1) = 0;

for i = [1:(2/dt)]

    gamma(i)= TARGET;

    dh_d(i) = 1-h_d(i);
    dx_d(i) = y_d(i);
    dy_d(i) = h_d(i)*b * (h_d(i)*b/4 *(gamma(i)-x_d(i)) - y_d(i));
    
    dh_d2(i) = 1-h_d2(i);
    dx_d2(i) = y_d2(i);
    dy_d2(i) = h_d2(i)*b * (h_d2(i)*b/4 *(gamma(i)-x_d2(i)) - y_d2(i));
    
    dh_d3(i) = 1-h_d3(i);
    dx_d3(i) = y_d3(i);
    dy_d3(i) = h_d3(i)*b * (h_d3(i)*b/4 *(gamma(i)-x_d3(i)) - y_d3(i));


    %*******EULER**************

    T(i+1)=T(i)+dt;

    h_d(i+1)=h_d(i)+dh_d(i)*dt;
    y_d(i+1)=y_d(i)+dy_d(i)*dt;
    x_d(i+1)=x_d(i)+dx_d(i)*dt;
    
    h_d3(i+1)=h_d3(i)+dh_d3(i)*dt;
    y_d3(i+1)=y_d3(i)+dy_d3(i)*dt;
    x_d3(i+1)=x_d3(i)+dx_d3(i)*dt;
    
    h_d2(i+1)=h_d2(i)+dh_d2(i)*dt;
    y_d2(i+1)=y_d2(i)+dy_d2(i)*dt;
    x_d2(i+1)=x_d2(i)+dx_d2(i)*dt;

end

figure;

subplot(2,1,1)
plot(T, x_d,'black', T, x_d2,'red--', T, x_d3,'blue-.', 'LineWidth',4)
xlabel('Time [s]', 'FontSize', 20)
ylabel('Position','FontSize',20)
lim = get(gca,'YLim');
axis manual;
set(gca, 'YLim',[lim(1)-0.5 lim(2)+0.5],'FontSize',20);

subplot(2,1,2)
plot(T, y_d,'black', T, y_d2,'red--', T, y_d3,'blue-.', 'LineWidth',4)
xlabel('Time [s]', 'FontSize', 20)
ylabel('Velocity','FontSize',20)
lim = get(gca,'YLim');
axis manual;
set(gca, 'YLim',[lim(1)-0.5 lim(2)+0.5],'FontSize',20);










    
