% Code to make figure 2c : influence of perturbations 

clear all;

%CONTROL COMMANDS

% target of the movement
TARGET = 2;

%VARIABLES: INITIAL CONDITIONS

h_d(1)=0;
x_d(1)=0;
y_d(1)=0;

h_d2(1)=0;
x_d2(1)=0;
y_d2(1)=0;

h_d3(1)=0;
x_d3(1)=0;
y_d3(1)=0;

h_d4(1)=0;
x_d4(1)=0;
y_d4(1)=0;


%PARAMETERS

%discrete system
b = 10;

% EQ + INTEGRATION

%integration
dt   = 0.001; %time step 
T(1) = 0;


for i = [1:(4/dt)]
    
    gamma(i)=TARGET;
    gamma2(i)=TARGET;
    

    % TOP FIGURE
    
    %%%%perturbed
    
    dh_d(i) = 1-h_d(i);
    dx_d(i) = y_d(i);
    dy_d(i) = h_d(i)*b * (h_d(i)*b/4 *(gamma(i)-x_d(i)) - y_d(i));
    
    %perturbations
    if(i>500 && i<1500)
        dx_d(i)=0;
    end
    
    %%% unperturbed
    dh_d3(i) = 1-h_d3(i);
    dx_d3(i) = y_d3(i);
    dy_d3(i) = h_d3(i)*b * (h_d3(i)*b/4 *(gamma(i)-x_d3(i)) - y_d3(i));
    
    
    % BOTTOM FIGURE

    %%%perturbed
    
    dh_d2(i) = 1-h_d2(i);
    dx_d2(i) = y_d2(i);
    dy_d2(i) = h_d2(i)*b * (h_d2(i)*b/4 *(gamma2(i)-x_d2(i)) - y_d2(i));
    
        
    if(i>1800 && i< 3000)
        dx_d2(i)=-1;
    end

    %%% unperturbed
    
    dh_d4(i) = 1-h_d4(i);
    dx_d4(i) = y_d4(i);
    dy_d4(i) = h_d4(i)*b * (h_d4(i)*b/4 *(gamma2(i)-x_d4(i)) - y_d4(i));
    


    %*******EULER**************

    T(i+1)=T(i)+dt;

    %discrete
    
    h_d(i+1)=h_d(i)+dh_d(i)*dt;
    y_d(i+1)=y_d(i)+dy_d(i)*dt;
    x_d(i+1)=x_d(i)+dx_d(i)*dt;
       
    h_d2(i+1)=h_d2(i)+dh_d2(i)*dt;
    y_d2(i+1)=y_d2(i)+dy_d2(i)*dt;
    x_d2(i+1)=x_d2(i)+dx_d2(i)*dt;
    
    h_d3(i+1)=h_d3(i)+dh_d3(i)*dt;
    y_d3(i+1)=y_d3(i)+dy_d3(i)*dt;
    x_d3(i+1)=x_d3(i)+dx_d3(i)*dt;
         
    h_d4(i+1)=h_d4(i)+dh_d4(i)*dt;
    y_d4(i+1)=y_d4(i)+dy_d4(i)*dt;
    x_d4(i+1)=x_d4(i)+dx_d4(i)*dt;

end

gamma(i+1) = gamma(i);
gamma2(i+1) = gamma2(i);

figure

subplot(2,1,1)
plot(T,gamma, 'blue-.', T, x_d3,'red--',T, x_d,'black', 'LineWidth',4)
xlabel('Time [s]', 'FontSize', 20)
ylabel('Position','FontSize',20)
lim = get(gca,'YLim');
axis manual;
set(gca, 'XLim', [0 4],'YLim',[lim(1)-0.5 lim(2)+0.5],'FontSize',20);
line([0.5 0.5],[lim(1)-0.5 lim(2)+0.5],'color','black','linewidth',2);
line([1.5 1.5],[lim(1)-0.5 lim(2)+0.5],'color', 'black', 'linewidth',2);
h=lim(2)-lim(1)+1;
y=lim(1)-0.5;

subplot(2,1,2)
plot(T,gamma2, 'blue-', T, x_d4,'red--',T, x_d2,'black',  'LineWidth',4)
xlabel('Time [s]', 'FontSize', 20)
ylabel('Position','FontSize',20)
lim = get(gca,'YLim');
axis manual;
set(gca, 'XLim', [0 4],'YLim',[lim(1)-0.5 lim(2)+0.5],'FontSize',20);
line([1.8 1.8],[lim(1)-0.5 lim(2)+0.5],'color','black','linewidth',2);
line([3.0 3.0],[lim(1)-0.5 lim(2)+0.5],'color','black','linewidth',2);









    
