% Code to make figure 2b : modulations of the target

clear all;

%CONTROL COMMANDS

%modulations of the target
for i=[1:200]
    gamma(i)=0;
    gamma2(i)=0;
end
for i =[200:4000]
    gamma(i)=-1;
end
for i=[1500:4001]
    gamma(i)=1;
end
for i=[200:4001]
    gamma2(i)=sin(i/500);
end


%VARIABLES: INITIAL CONDITIONS

h_d(1)=0;
x_d(1)=0;
y_d(1)=0;

h_d2(1)=0;
x_d2(1)=0;
y_d2(1)=0;

%PARAMETERS

%discrete system
b = 50;

% EQ + INTEGRATION

%integration
dt   = 0.001; %time step
T(1) = 0;


for i = [1:(4/dt)]

   
    %if the target is significantly changed (more than 0.1 rad here), we reset the go command to zero
    if(i>2)
        if(gamma(i)>(gamma(i-1)+0.1) || gamma(i)<(gamma(i-1)-0.1))
            h_d(i)=0;
        end
    end
 
    if(i>2)
        if(gamma2(i)>(gamma2(i-1)+0.1) || gamma2(i)<(gamma2(i-1)-0.1))
            h_d2(i)=0;
        end
    end
       

    %DISCRETE SYSTEM

    dh_d(i) = 1-h_d(i);
    dx_d(i) = y_d(i);
    dy_d(i) = h_d(i)*b * (h_d(i)*b/4 *(gamma(i)-x_d(i)) - y_d(i));

    dh_d2(i) = 1-h_d2(i);
    dx_d2(i) = y_d2(i);
    dy_d2(i) = h_d2(i)*b * (h_d2(i)*b/4 *(gamma2(i)-x_d2(i)) - y_d2(i));


    %*******EULER**************

    T(i+1)=T(i)+dt;

    %discrete
    h_d(i+1)=h_d(i)+dh_d(i)*dt;
    y_d(i+1)=y_d(i)+dy_d(i)*dt;
    x_d(i+1)=x_d(i)+dx_d(i)*dt;
    
        
    h_d2(i+1)=h_d2(i)+dh_d2(i)*dt;
    y_d2(i+1)=y_d2(i)+dy_d2(i)*dt;
    x_d2(i+1)=x_d2(i)+dx_d2(i)*dt;




end

figure

subplot(2,1,1)
plot(T, gamma,'red-.', T, x_d,'black', 'LineWidth',4)
xlabel('Time [s]', 'FontSize', 20)
ylabel('Position','FontSize',20)
lim = get(gca,'YLim');
axis manual;
set(gca, 'XLim', [0 4],'YLim',[lim(1)-0.5 lim(2)+0.5],'FontSize',20);

subplot(2,1,2)
plot(T, gamma2,'red-.', T, x_d2,'black','LineWidth',4)
xlabel('Time [s]', 'FontSize', 20)
ylabel('Position','FontSize',20)
lim = get(gca,'YLim');
axis manual;
set(gca, 'XLim', [0 4],'YLim',[lim(1)-0.5 lim(2)+0.5],'FontSize',20);




    
