% Code to make figure 3c : Hopf birfucation + modulation of the amplitude

clear all;


%integration
dt   = 0.001; %time step 
T(1) = 0;
time = 6; %total time


%CONTROL COMMANDS

for i=[1:(time/dt+1)]
    omega(i)=3*pi;
    omega2(i)=3*pi;
    mu(i)=1; 
    sm(i)=1; %square of the amplitude (used for the graph)
    mu2(i)=1;
end
for i=[1000:2000]
    mu(i)=-5;
    sm(i)=0;
end
for i=[2000:4000]
    mu(i)=4;
    sm(i)=2;
end
for i=[4000:6001]
    mu(i)=0.25;
    sm(i)=0.5;
end


%PARAMETRES

%oscillators
a = 5;
c = 20;

%VARIABLES: INITIAL CONDITIONS

%we don't start at (0,0) as the convergence would be slower 

m(1)=0;
x_h(1)=1;
v_h(1)=0;

m2(1)=0;
x_h2(1)=1;
v_h2(1)=0;

m3(1)=0;
x_h3(1)=1;
v_h3(1)=0;




for i = [1:(time/dt)]
          
    r_h = sqrt(x_h(i)^2 + v_h(i)^2);        
    dm(i)=c*(mu(i)-m(i));
    dx_h(i) = a/abs(mu(i)) * (m(i)-r_h^2) * x_h(i) - omega(i) * v_h(i)+randn;
    dv_h(i) = a/abs(mu(i)) * (m(i)-r_h^2) * v_h(i) + omega(i)* x_h(i)+randn;
    
    r_h2 = sqrt(x_h2(i)^2 + v_h2(i)^2);
    dm2(i)=c*(mu2(i)-m2(i));  
    dx_h2(i) = a/abs(mu2(i)) * (m2(i)-r_h2^2) * x_h2(i) - omega2(i) * v_h2(i)+randn;
    dv_h2(i) = a/abs(mu2(i)) * (m2(i)-r_h2^2) * v_h2(i) + omega2(i)* x_h2(i)+randn;



    %*******EULER**************

    T(i+1)=T(i)+dt;

    x_h(i+1)=x_h(i)+dx_h(i)*dt;
    v_h(i+1)=v_h(i)+dv_h(i)*dt;
    m(i+1) = m(i) + dm(i)*dt;
    
    x_h2(i+1)=x_h2(i)+dx_h2(i)*dt;
    v_h2(i+1)=v_h2(i)+dv_h2(i)*dt;
    m2(i+1) = m2(i) + dm2(i)*dt;

    


end
sm(i+1)=sm(i);

figure
subplot(2,1,1)
plot( T, sm, 'blue .',T, -sm, 'blue .',T, x_h2,'black--',T,x_h, 'red' ,'LineWidth',4)
xlabel('Time [s]', 'FontSize', 20)
ylabel('Position','FontSize',20)
%lim = get(gca,'YLim');
axis manual;
set(gca, 'XLim', [0 time], 'Ylim', [-2.5 2.5],'FontSize',20);
% 
subplot(2,1,2)
plot(x_h,v_h, 'red', x_h2, v_h2,'black--','LineWidth',4)
xlabel('x', 'FontSize', 20)
ylabel('z','FontSize',20)
lim = get(gca,'YLim');
lim2 =get(gca,'Xlim');
axis manual;
set(gca, 'XLim', [-2.5 2.5],'YLim',[-2.5 2.5],'FontSize',20);






